<template>
  <div class="px-5">
    <v-card
      max-width="100%"
      flat
      class="mx-auto my-5 pb-5   grey lighten-3"
    >
      <v-card
        class="card d-flex flex-wrap mx-3"
        color="primary"
        dark
      >
        <v-col
          class="text-center"
          cols="12"
          sm="6"
        >
          <span
            class="subtitle-1"
          >
            LIST OF LEAVE TYPE
          </span>
        </v-col>
         <v-col
          class="text-center"
          cols="12"
          sm="6"
        >
          <v-btn
            class="mx-auto"
            tile outlined
            :disabled="disabled"
            color="white"
            to="/leaveform"
          >
            <v-icon left>mdi-folder-plus</v-icon> ADD LEAVE TYPE
          </v-btn>
        </v-col>
      </v-card>
      <v-row
        class="my-3 hidden-xs-only"
        no-gutters
      >
        <v-col class="text-center">
          <span class="caption black--text">LEAVE NAME</span>
        </v-col>
        <v-col class="text-center">
          <span class="caption black--text">DESCRIPTION</span>
        </v-col>
        <v-col class="text-center">
          <span class="caption black--text">CREATED DATE</span>
        </v-col>
        <v-col class="text-center">
          <span class="caption black--text">ACTION</span>
        </v-col>
      </v-row>
      <v-divider class="mb-4"></v-divider>
      <v-row
        outlie
        v-for="(item, index) in notes"
        :key="item.id"
        class="my-3 mx-2 white py-4 row_outlined"
        no-gutters
      >
        <v-col class="text-center" cols="12" sm="3">
          <span class="caption black--text hidden-sm-and-up px-3">LEAVE NAME :</span>
          <span class="caption black--text">{{ item.leavetype }}</span>
        </v-col>
        <v-col class="text-center" cols="12" sm="3">
          <span class="caption black--text hidden-sm-and-up px-3">DESCRIPTION :</span>
          <span class="caption black--text">{{ item.description }}</span>
        </v-col>
        <v-col class="text-center" cols="12" sm="3">
          <span class="caption black--text hidden-sm-and-up px-3">CREATED DATE :</span>
          <span class="caption black--text">{{ [item.dateCreated, 'x'] | moment('D MMM YY')}}</span>
        </v-col>
        <v-col class="text-center" cols="12" sm="3">
          <span class="caption black--text hidden-sm-and-up px-3">ACTION :</span>
          <v-btn icon
            class="secoundary--text mx-auto"
            :disabled="disabled"
            :to="{ name: 'LeaveEdit', params: { id: `${item.id}` }}"
          >
            <v-icon>mdi-pencil</v-icon>
          </v-btn>
          <v-btn
            icon
            :disabled="disabled"
            class="secoundary--text mx-auto"
            v-on:click="deleteNote(index)"
          >
            <v-icon>mdi-delete</v-icon>
          </v-btn>
         </v-col>
      </v-row>
      <v-row class="px-7 py-3">
        <v-btn class="mx-2" :disabled="prevBtnDisabled" @click="prev">Prev</v-btn>
        <v-btn class="mx-2" :disabled="nextBtnDisabled" @click="next">Next</v-btn>
      </v-row>
    </v-card>
  </div>
</template>
<script>
// import db from '@/fb';
import { mapGetters } from 'vuex';
import { getAuthenticatedUser } from '@/fb';
import Note from '@/models/Note';
import { getCurrentUser } from '@/firebase/db';
import UserNoteList from '@/models/UserNoteList';

export default {
  data() {
    return {
      leave: [],
      notes: [],
      disabled: true,
      prevBtnDisabled: true,
      nextBtnDisabled: true,
    };
  },
  computed: {
    ...mapGetters({
      user: 'getUser',
    }),
  },
  mounted() {
    getCurrentUser().getIdTokenResult().then((idTokenResult) => {
      if (idTokenResult.claims.admin) {
        this.disabled = false;
      } else {
        this.disabled = true;
      }
    });
    getAuthenticatedUser().then((user) => {
      this.userNotes = new UserNoteList(
        { uid: user.uid, className: Note.getClassName() },
      );
      console.log('this function work');
      this.userNotes.fetch({ orderBy: 'dateCreated', paginate: true })
        .then((page) => {
          this.notes = page.data;
          console.log('this is final list you are seeing right now  !!!!!!!!!!!!!!!', this.notes);
          if (page.hasNext()) {
            this.nextBtnDisabled = false;
            console.log('@@222', this.nextBtnDisabled);
          }
        });
    });
  },
  created() {
  },
  methods: {
    next() {
      this.userNotes.next().then((page) => {
        // this.$log.debug(noteList);
        this.notes = page.data;
        this.prevBtnDisabled = false;
        if (page.hasNext()) {
          this.nextBtnDisabled = false;
        } else {
          this.nextBtnDisabled = true;
        }
      });
    },
    prev() {
      this.userNotes.prev().then((page) => {
        this.notes = page.data;
        this.nextBtnDisabled = false;
        if (page.hasPrevious()) {
          this.prevBtnDisabled = false;
        } else {
          this.prevBtnDisabled = true;
        }
      });
    },
    deleteNote(index) {
      // XXX: This only deletes the note from current page
      // but not from ListModel
      this.notes[index].delete().then(() => {
        this.notes.splice(index, 1);
      });
    },
  },
};
</script>

<style scoped>
.card {
  top: -10px;
}
.row_outlined {
  outline: #1b0052 solid 1px;
  margin: auto;
}
</style>
